using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data;               // For MySQL
using MySql.Data.MySqlClient;   // For MySQL
using System.Diagnostics;       // To do emailStatus()


namespace Garden
{
    public partial class Form1 : Form
    {
        string RxString, testS, tempS, light, Temp1, Temp2, Temp3, moist1, moist2 = "";
        double workD, tmp1, tmp2, tmp3, m1, m2 = 0;
        char call = '0';
        char[] buff = new char[1];
        char[] conv = new char[70];
        int l1, c2, lightOnH, lightOnM, lightOffH, lightOffM = 0;
        int count = 0;
        bool state = false;

        public Form1()
        {
            InitializeComponent();
            // Hide some buttons and textboxes. I wanted to create a seperate form to set variables
            // ie. light on time. I couldn't figure out how to pass variables between forms in c#.
            // This will be on my wishlist for later versions. For now I hide things to create more
            // space on the form.
            label3.Visible = false;
            label4.Visible = false;
            label5.Visible = false;
            label6.Visible = false;
            lonhBOX.Visible = false;
            lonmBOX.Visible = false;
            loffhBOX.Visible = false;
            loffmBOX.Visible = false;
            saveBUT.Visible = false;
            CancelBUT.Visible = false;
        }
        

        private void buttonStart_Click(object sender, EventArgs e) // Lets start things.
        {                                                   // All intervals needs to be save in "settings" table. Todo.
            timer1.Interval = 10000;                        // Timer for 10 seconds. I display values on the from every
                                                            // 10 seconds.
            timer1.Enabled = true;                          // Start the timer.
            timer1.Tick += new EventHandler(timer1_Tick);   // Setup the event handler for the timer.
            timer2.Interval = 500;                          // This happens every .5 second to to update the date/time
                                                            // field on the form.
            timer2.Enabled = true;
            timer2.Tick += new EventHandler(timer2_Tick);
            timer3.Interval = 3600000;                      // Interval at which to email status to owner.
            timer3.Enabled = true;
            timer3.Tick += new EventHandler(timer3_Tick);
            serialPort1.PortName = "COM3";                  // USB serial port number.
                                                            // Need to make this changeble through setting settings.
                                                            // To save in the database in the "settings" table.
            serialPort1.BaudRate = 9600;                    // Serial port speed.
                                                            // Sometimes I need to reset the arduino via button on the baord
                                                            // to get things going at startup. Not sure why the serial
                                                            // communication does not always work straight away. Once reset and
                                                            // working it keeps working, so it doesn't bug me too much. FYI.
            serialPort1.Open();                             // Open serial port for comms.
            if (serialPort1.IsOpen)
            {
                buttonStart.Enabled = false;
                buttonStop.Enabled = true;
            }
            ReadMyData();                                   // Get settings from "settings" table.
            CallA();                                        // Send char "a" to the arduino to get values.
        }

        private void emailStatus()
        {
            Process myProc;
            // Start the process.
            // Get SendEmail here: http://caspian.dotconf.net/menu/Software/SendEmail/
            myProc = Process.Start("c:\\email\\sendEmail.exe", "-f your@email.com -t your@email.com -u Status -m " + l1 + "," + tmp1 + "," + tmp2 + "," + tmp3 + "," + m1 + "," + m2 + "; -s your.smtp.com -xu username -xp password");
            // Stop the process.
            myProc.CloseMainWindow();
        }


        private void buttonStop_Click(object sender, EventArgs e) // Stop stop everything.
        {
            if (serialPort1.IsOpen)
            {
                timer1.Enabled = false;         // Stoip the timers.
                timer2.Enabled = false;
                timer3.Enabled = false;
                serialPort1.Close();            // Close the serial port.
                buttonStart.Enabled = true;     
                buttonStop.Enabled = false;
             }

        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {

            if (serialPort1.IsOpen) serialPort1.Close();        // Close to port if we leave.
        }

        private void DisplayText(object sender, EventArgs e)    // Display form values. You can look here for the
                                                                // forms text names.
        {
            
            lightBox.Text = light;                      // Display values in textboxes.
            m1Box.Text = moist1;
            m2Box.Text = moist2; 
            workD = Convert.ToDouble(Temp1) / 10000;    // Get our desimal places back.
            tmp1 = workD;                               // Save for Database save.
            tempS = workD.ToString("N2");
            tempBox1.Text = tempS;
            workD = Convert.ToDouble(Temp2) / 10000;
            tmp2 = workD;
            tempS = workD.ToString("N2");
            tempBox2.Text = tempS;
            workD = Convert.ToDouble(Temp3) / 10000;
            tmp3 = workD;
            tempS = workD.ToString("N2");
            tempBox3.Text = tempS;

            if (state)
            {
                stateTextBox.Text = "On";
            }
            else
            {
                stateTextBox.Text = "Off";
            }
            c2 = c2 + 1;

            if (c2 == 6)                        // Every 6 10 seconds save to databse. This is quite alot of datapoints.
            {
                l1 = Convert.ToInt16(light);    // Convert values to save in the databse.
                m1 = Convert.ToInt16(moist1);
                m2 = Convert.ToInt16(moist2);
                c2 = 0;
                // Setup connection string.
                MySqlConnection MyCon = new MySqlConnection("SERVER=localhost;" + "DATABASE=garden2;" + "UID=root;" + "PASSWORD=password;");
                // Open connection.
                MyCon.Open();
                // Setup the SQL string.
                MySqlCommand command = new MySqlCommand("insert into readings values (null, null," + l1 + "," + tmp1 + "," + tmp2 + "," + tmp3 + "," + m1 + "," + m2 + ")", MyCon);
                // Execute the SQL string on the database.
                command.ExecuteNonQuery();
                // Close Database connection.
                MyCon.Close();

                // Do some logic to determine wheather to switch the light on or off. This could probably be done in a seperate timer event.
                if (DateTime.Now.Hour >= lightOnH)
                {
                    if (DateTime.Now.Hour >= lightOffH)
                    {
                        if (DateTime.Now.Minute >= lightOffM)
                        {
                            CallC(); // Light off.
                        }
                    }
                    else
                    {
                        if (DateTime.Now.Minute >= lightOnM)
                        {
                            CallB(); //Light on.
                        }
                    }

                }
                else
                {
                    CallC(); // Light off.
                }
            }
         }

        private void Sort(object sender, EventArgs e)   // Dissect the string we got from the arduino.
        {
            testS = "~";            // The value break char.
            light = "";             // Clear all values.
            Temp1 = "";
            Temp2 = "";
            Temp3 = "";
            moist1 = "";
            moist2 = "";
            count = 0;
            while (RxString[count] != testS[0])     // Check first char for break value(~). Repeat till found.
            {
                light = light + RxString[count];    // If not add the char to new string(light).
                count += 1;                         // Goto next char.
            }
            count += 1;                             // Lets go on to the next char via (count).
            while (RxString[count] != testS[0])
            {
                Temp1 = Temp1 + RxString[count];
                count += 1;
            }
            count += 1;
            while (RxString[count] != testS[0])
            {
                Temp2 = Temp2 + RxString[count];
                count += 1;
            }
            count += 1;
            while (RxString[count] != testS[0])
            {
                Temp3 = Temp3 + RxString[count];
                count += 1;
            }
            count += 1;
            while (RxString[count] != testS[0])
            {
                moist1 = moist1 + RxString[count];
                count += 1;
            }
            count += 1;
            while (RxString[count] != testS[0])
            {
                moist2 = moist2 + RxString[count];
                count += 1;
            }
            // Add more while statements for extra values from arduino.
        }

        public void ReadMyData()            // Read "settings" table.
        {
            // SQL query string.
            string mySelectQuery = "SELECT LOnH, LOnM, LOffH, LOffM FROM settings";
            // Database connection string.
            MySqlConnection myConnection = new MySqlConnection("SERVER=localhost;" + "DATABASE=garden2;" + "UID=root;" + "PASSWORD=password;");
            MySqlCommand myCommand = new MySqlCommand(mySelectQuery, myConnection);
            // Open database connection.
            myConnection.Open();
            MySqlDataReader myReader;
            // Execute query string.
            myReader = myCommand.ExecuteReader();
            // Always call Read before accessing data.
            while (myReader.Read())
            {
                lightOnH = myReader.GetInt16(0);
                lightOnM = myReader.GetInt16(1);
                lightOffH = myReader.GetInt16(2);
                lightOffM = myReader.GetInt16(3);
            }
            // Always call Close when done reading.
            myReader.Close();
            // Close the connection when done with it.
            myConnection.Close();
        }     

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e) // We have data at the port.
        {
            System.Threading.Thread.Sleep(50);      // A delay to make sure all the data is recieved at the port.
            switch (call)
            {
                case 'a':                                       // We called a "a".
                    RxString = "";                              // Clear the recieve string.
                    RxString = serialPort1.ReadExisting();      // Get the data from the port.
                    this.Invoke(new EventHandler(Sort));        // Dissect the string into individual values.
                    this.Invoke(new EventHandler(DisplayText)); // Display the values on the form.
                break;
                case 'c':       // We called a "c". Future use. 
                break;
                case 'd':       // We called a "d". Future use.
                break;
                case 'e':       // We called a "e". Future use.
                break;
           }
        }

        private void CallA()                    // Send char "a" to serial port.
        {
            if (!serialPort1.IsOpen) return;
            buff[0] = 'a';
            call = 'a';                         // Used to see what call we made to the arduino.
            serialPort1.Write(buff, 0, 1);
        }

        private void CallB()                    // Send char "b" to serial port.
        {
            if (!state)
            {
                if (!serialPort1.IsOpen) return;
                buff[0] = 'b';
                call = 'b';
                serialPort1.Write(buff, 0, 1);
                state = true;
            }
        }

        private void CallC()                    // Send char "c" to serial port.
        {
            if (state) {
            if (!serialPort1.IsOpen) return;
            buff[0] = 'c';
            call = 'c';
            serialPort1.Write(buff, 0, 1);
            state = false;
            }
        }

        private void wtime()        // Writes date/time to forms textbox.
        {
            DateBox.Text = Convert.ToString(DateTime.Now);
        }

        private void timer1_Tick(object sender, System.EventArgs e)  // Timer event.
        {
            CallA();        // Send "a". Get values.
         }

        private void timer2_Tick(object sender, System.EventArgs e)
        {
            wtime();        // Call wtime function.
        }

        private void timer3_Tick(object sender, System.EventArgs e)
        {
            emailStatus();  // Call emailStatus function.
        }

        private void lightOn_Click(object sender, EventArgs e)  // Send light on commend to arduino. Char "b".
        {
            if (!serialPort1.IsOpen) return;
            buff[0] = 'b';
            call = 'b';
            serialPort1.Write(buff, 0, 1);
            state = true;
        }

        private void lightOff_Click(object sender, EventArgs e) // Send light off commend to arduino. Char "c".
        {
            if (!serialPort1.IsOpen) return;
            buff[0] = 'c';
            call = 'c';
            serialPort1.Write(buff, 0, 1);
            state = false;
        }

        private void settingsBUT_Click(object sender, EventArgs e) // Let's enter new settings. 
        {
            ReadMyData();                   // Get the data from the "settings" table.
            stateTextBox.Visible = false;
            lightOn.Visible = false;
            lightOff.Visible = false;
            label3.Visible = true;
            label4.Visible = true;
            label5.Visible = true;
            label6.Visible = true;
            lonhBOX.Visible = true;
            lonmBOX.Visible = true;
            loffhBOX.Visible = true;
            loffmBOX.Visible = true;
            saveBUT.Visible = true;
            CancelBUT.Visible = true;
            lonhBOX.Text = Convert.ToString(lightOnH);
            lonmBOX.Text = Convert.ToString(lightOnM);
            loffhBOX.Text = Convert.ToString(lightOffH);
            loffmBOX.Text = Convert.ToString(lightOffM);
        }

        private void CancelBUT_Click(object sender, EventArgs e)    // Cancel. No change saved to table.
        {
            label3.Visible = false;
            label4.Visible = false;
            label5.Visible = false;
            label6.Visible = false;
            lonhBOX.Visible = false;
            lonmBOX.Visible = false;
            loffhBOX.Visible = false;
            loffmBOX.Visible = false;
            saveBUT.Visible = false;
            CancelBUT.Visible = false;
            stateTextBox.Visible = true;
            lightOn.Visible = true;
            lightOff.Visible = true;
        }

        private void saveBUT_Click(object sender, EventArgs e)  // Save settings changes to "settings" table.
        {
            lightOnH = Convert.ToInt16(lonhBOX.Text);       // Convert textbox strings to integers.
            lightOnM = Convert.ToInt16(lonmBOX.Text);
            lightOffH = Convert.ToInt16(loffhBOX.Text);
            lightOffM = Convert.ToInt16(loffmBOX.Text);   
            // Open Database connection.
            MySqlConnection MyCon = new MySqlConnection("SERVER=localhost;" + "DATABASE=garden2;" + "UID=root;" + "PASSWORD=password;");
            MyCon.Open();
            // Update table SQL string.
            MySqlCommand command = new MySqlCommand("update settings set LOnH=" + lightOnH + ", LOnM =" + lightOnM + ", LOffH=" + lightOffH + ", LOffM=" + lightOffM, MyCon);
            command.ExecuteNonQuery();
            // Close Database connection.
            MyCon.Close();
            // Fix the form.
            label3.Visible = false;
            label4.Visible = false;
            label5.Visible = false;
            label6.Visible = false;
            lonhBOX.Visible = false;
            lonmBOX.Visible = false;
            loffhBOX.Visible = false;
            loffmBOX.Visible = false;
            saveBUT.Visible = false;
            CancelBUT.Visible = false;
            stateTextBox.Visible = true;
            lightOn.Visible = true;
            lightOff.Visible = true;
        }
    }
}